package dev.fitko.fitconnect.client.cmd.util;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import java.util.UUID;

import static org.junit.jupiter.api.Assertions.*;

class UUIDConverterTest {

    UUIDConverter underTest;

    @BeforeEach
    void setUp() {
        underTest = new UUIDConverter("option");
    }

    @Test
    void testConvertStringToUUID() {
        // Given
        final var uuidString = "d82dad6e-0d0a-11ed-861d-0242ac120002";

        // When
        final UUID uuid = underTest.convert(uuidString);

        // Then
        assertNotNull(uuid);
        assertEquals(uuid.toString(), uuidString);
    }

    @Test
    void testConvertIllegalUUIDString() {
        assertThrows(IllegalArgumentException.class, () -> underTest.convert("d82dad6e-0d0a-"));
    }
}