package dev.fitko.fitconnect.core.auth;

import dev.fitko.fitconnect.api.domain.auth.OAuthToken;
import org.junit.jupiter.api.Test;
import org.springframework.web.client.RestTemplate;

import static org.junit.jupiter.api.Assertions.*;

class OAuthTokenIntegrationTest {

    @Test
    void retrieveAuthenticationToken() {

        // Given
        final var tokenUrl = "https://auth-testing.fit-connect.fitko.dev/token";
        final var clientId = "781f6213-0f0f-4a79-9372-e7187ffda98b";
        final var secret = "PnzR8Vbmhpv_VwTkT34wponqXWK8WBm-LADlryYdV4o";
        final var scope1 = "send:region:DE";
        final var scope2 = "send:region:EN";

        final var authService = new DefaultOAuthService(new RestTemplate(), clientId, secret, tokenUrl);

        // When
        final OAuthToken token = authService.getCurrentToken();

        // Then
        assertNotNull(token);
        assertNull(token.getError());
        assertNotNull(token.getAccessToken());
        assertEquals(1800, token.getExpiresIn());
    }
}