package dev.fitko.fitconnect.core.testutil;

import ch.qos.logback.classic.spi.LoggingEvent;
import ch.qos.logback.core.AppenderBase;

import java.util.ArrayList;
import java.util.List;

import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertTrue;

public final class LogCaptor extends AppenderBase<LoggingEvent> {

    private static final List<LoggingEvent> events = new ArrayList<>();

    @Override
    protected void append(final LoggingEvent e) {
        events.add(e);
    }

    public void assertContains(final String expected){
        assertTrue(filterEvents(expected));
    }

    public void assertContainsNot(final String expected) {
        assertFalse(filterEvents(expected));
    }

    private boolean filterEvents(final String expected) {
        return events.stream().map(LoggingEvent::getFormattedMessage).anyMatch(msg -> msg.contains(expected));
    }
}